'use strict';

var React = require('react');
var reactCodemirror2 = require('react-codemirror2');
require('codemirror-one-light-theme/one-light.css');
require('codemirror/lib/codemirror.css');
require('codemirror/theme/material.css');
require('codemirror/theme/neat.css');
require('codemirror/theme/neo.css');
require('codemirror/mode/yaml/yaml.js');
require('codemirror/mode/xml/xml.js');
require('codemirror/mode/javascript/javascript.js');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var CodeEditor = /** @class */ (function (_super) {
    __extends(CodeEditor, _super);
    function CodeEditor() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.value || '',
            isInnerChange: false,
        };
        _this.onBeforeChange = function (_, __, value) {
            _this.setState({ value: value, isInnerChange: true });
        };
        _this.onChange = function (_, __, value) {
            if (_this.props.onChange) {
                _this.props.onChange(value);
            }
        };
        return _this;
    }
    // TODO~
    // componentWillReceiveProps(nextProps) {
    //   this.setState({ value: nextProps.value })
    // }
    // 不使用 componentWillReceiveProps, 只能用 isInnerChange 黑科技
    CodeEditor.getDerivedStateFromProps = function (nextProps, prevState) {
        if (nextProps.value !== prevState.value &&
            prevState.isInnerChange === false) {
            return { value: nextProps.value };
        }
        return { isInnerChange: false };
    };
    CodeEditor.prototype.render = function () {
        var _a = this.props, mode = _a.language, theme = _a.theme;
        return (React.createElement("div", { className: "leaf-editor" },
            React.createElement(reactCodemirror2.Controlled, { className: mode + " " + theme, value: this.state.value, options: {
                    mode: mode,
                    theme: theme,
                    lineNumbers: true,
                }, onBeforeChange: this.onBeforeChange, onChange: this.onChange })));
    };
    CodeEditor.defaultProps = {
        theme: 'one-light',
        value: '',
    };
    return CodeEditor;
}(React.PureComponent));

module.exports = CodeEditor;
//# sourceMappingURL=index.cjs.js.map
